import React from 'react';
import Winner from './Winner';
import './App.css';

export default class App extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            num1: Math.ceil(Math.random() * 20),
            num2: Math.ceil(Math.random() * 20),
            response: "",
            incorrect: false,
            score: 0
        };
    }

    render() {
        if (this.state.score === 5) {
            return this.renderWin();
        } else {
            return this.renderProblem();
        }
    }

    renderProblem() {
        return (
            <div>
                <div id="score">
                    Current score: {this.state.score}
                </div>
                <hr />
                <div id="problem" className={this.state.incorrect ? "incorrect" : ""}>
                    {this.state.num1} + {this.state.num2}
                </div>
                <input onKeyPress={this.inputKeyPress.bind(this)} onChange={this.updateResponse.bind(this)} value={this.state.response} />
                <button onClick={this.resetGame.bind(this)}>Reset</button>
            </div>
        );
    }

    renderWin() {
        const name = "the addition game";
        return (
            <Winner name={name} />
        );
    }

    updateResponse(event) {
        this.setState({
          response: event.target.value
        });
    }

    inputKeyPress(event) {
        if (event.key === "Enter") {
            const answer = parseInt(this.state.response);
            if (answer === this.state.num1 + this.state.num2) {
                this.setState((state) => {
                  return {
                    num1: Math.ceil(Math.random() * 20),
                    num2: Math.ceil(Math.random() * 20),
                    response: "",
                    incorrect: false,
                    score: state.score + 1
                  }
                });
            } else {
                this.setState({
                    response: "",
                    incorrect: true
                });
            }
        }
    }

    resetGame(event) {
        this.setState({
            num1: Math.ceil(Math.random() * 20),
            num2: Math.ceil(Math.random() * 20),
            response: "",
            incorrect: false,
            score: 0
        });
    }
}
